--[[
************************************************************************
Project				: Broker_HitCrit
Author				: zhinjio
Project Revision	: r3
Project Date		: 20081102022654

File				: Broker_HitCrit.lua
Commit Author		: zhinjio
Commit Revision		: 3
Commit Date			: 20081102022654
************************************************************************
Description	:
	Main addon file. 

TODO		:
	Figure out sound notify
	Figure out notify area notify

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

HitCrit_VERSION = 0.1
-- SKG_DEBUG = true
HitCrit_DEBUG = true

local HitCrit = LibStub( "AceAddon-3.0" ):NewAddon( "HitCrit", "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "HitCrit" )
_G["HitCrit"] = HitCrit

function HitCrit_Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\Broker_HitCrit\\icon:" .. fh .. "\124t"
	if not ( msg == nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " HitCrit: " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function HitCrit_Debug( msg )
	if not ( msg == nil ) then
		if ( HitCrit_DEBUG ) then
			HitCrit_Print( "DEBUG: " .. msg )
		end
	end
end

function HitCrit:AlertNew( crit, heal, target, spellName, amount )
	local db = self.db.factionrealm
	local hType, hStr = L["Hit"], L["hit"]
	if ( heal == 1 ) then
		hStr = L["healed"]
		if ( crit == 1 ) then
			hType = L["Critical Heal"]
		else
			hType = L["Heal"]
		end
	else
		if ( crit == 1 ) then
			hType = L["Critical Hit"]
		end
	end
	if ( db.alerts.chatframe == true ) then
		HitCrit_Print( string.format( L["New Record %s! %s %s %s for %d"], hType, spellName, hStr, target, amount ) )
	end
	if ( db.alerts.notify == true ) then
		-- Still need to figure this out
	end
	if ( db.alerts.sounds == true ) then
		-- Still need to figure this out
	end
end

function HitCrit:COMBAT_LOG_EVENT_UNFILTERED( _, _, eType, sGUID, sName, sFlags, dGUID, dName, dFlags, ... )
-- Parameters:
--	event		COMBAT_LOG_EVENT_UNFILTERED
--	timestamp
--	eType		event type (for example, SPELL_DAMAGE)
--	sGUID		source GUID
--	sName		source Name
--	sFlags		source Flags
--	dGUID		destination GUID
--	dName		destination Name
--	dFlags		destination Flags
--
--		The remaining parameters are dependent on eType
--
--		For RANGE_, SPELL_, SPELL_AURA_ and SPELL_PERIODIC_ prefixes, you have the following
--			spellId
--			spellName
--			spellSchool
--
--		Then, for _DAMAGE suffixes:
--			amount
--			overkill
--			school
--			resisted
--			blocked
--			absorbed
--			critical (1 or nil)
--			glancing (1 or nil)
--			crushing (1 or nil)
--
--		Then, for _HEAL suffixes:
--			amount
--			overhealing
--			critical
--
	local db = self.db.factionrealm
	local effect, id, hit, crit, sch, heal = "", 0, 0, 0, 0, 0
	if ( sGUID == HitCrit.GUID ) then
		-- First, check for damage
		if ( db.options.tracking.damage ) then
			if ( eType == "SWING_DAMAGE" ) then
				local amount, _, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = school
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_DAMAGE" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, crit, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
		if ( db.options.tracking.healing ) then
			if ( eType == "SWING_HEAL" ) then
				-- does this event exist?
				local amount, overheal, crit = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = 1; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
	elseif ( ( self.db.factionrealm.options.tracking.againstMe == true ) and ( dGUID == HitCrit.GUID ) ) then
	end
	if ( effect ~= "" ) then
		if ( db.values[id] ) then
			-- this value already exists. Compare to current, and replace if needed
			if ( crit ~= 0 ) then
				if ( crit > db.values[id].crit ) then
					HitCrit:AlertNew( 1, heal, dName, effect, crit )
					db.values[id].crit = crit
				end
			else
				if ( hit > db.values[id].hit ) then
					HitCrit:AlertNew( 0, heal, dName, effect, hit )
					db.values[id].hit = hit
				end
			end
		else
			-- Otherwise, we've got a new previously untracked value. Record all the info
			db.values[id] = {}
			db.values[id].hit = hit
			db.values[id].crit = crit
			db.values[id].effect = effect
			db.values[id].target = dName
			db.values[id].school = sch
			if ( crit ~= 0 ) then
				HitCrit:AlertNew( 1, heal, dName, effect, crit )
			else
				HitCrit:AlertNew( 0, heal, dName, effect, hit )
			end
		end
	end
end

local LDB = LibStub( "LibDataBroker-1.1", true )
local LTT = LibStub( "LibTooltip-1.0" , true )
local launcher = LDB:NewDataObject( "HitCrit", {
	type = "data source",
	text = "HitCrit",
	label = "Broker_HitCrit",
	icon = "Interface\\Addons\\Broker_HitCrit\\icon",
	OnTooltipShow = function( tooltip )
		local db = HitCrit.db.factionrealm
		tooltip = LTT:Acquire("HitCritTT", 3, "LEFT", "CENTER", "RIGHT") or GameTooltip
		-- The way we display things is different depending on whether we are displaying by school or not
		tooltip:AddHeader( nil, "HitCrit" )
		tooltip:AddLine( "test1", "test2", "test3" )
	end,		
} )

local defOpts = {
	factionrealm = {
		options = {
			tracking = {
				pvp = false,
				againstMe = false,
				damage = true,
				healing = true,
				environmental = false,
			},
			display = {
				hit = true,
				crit = true,
				enemyName = false,
				type = false,
			},
			alerts = {
				sound = false,
				notify = false,
				chatframe = true,
			},
		},
-- Values will be in the following format:
--		SpellID = {
--			effect = spellName,
--			hit = value,
--			crit = value,
--			target = Name,
--			school = schoolID,
--		} -- In the case of normal white melee damage, SpellID will be 0
		values = {
		}
	}
}

-- on init
function HitCrit:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub( "AceDB-3.0" ):New( "HitCrit_DB", defOpts, "Default" )

	HitCrit.me = UnitName( "player" )
	HitCrit.GUID = UnitGUID( "player" )
	HitCrit.level = UnitLevel( "player" )

	-- do we have any data yet for this toon? If not, init its table
	if not ( self.db.factionrealm[HitCrit.me] ) then
		self.db.factionrealm[HitCrit.me] = {}
	end

	HitCrit_Debug( "In OnInit" )
	-- Event listeners
    HitCrit:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

--[[
************************************************************************
CHANGELOG:

Date : 10/29/08
	Initial version
************************************************************************
]]--